LPARAMETERS loForm, lcName, logrd
loForm.ADDOBJECT(lcName,'Patch',logrd)

DEFINE CLASS Patch AS CONTAINER
	logrd=.F.
	MyRelativeBaseRow = 1
	MyTopRecno = 1
	grdActiveRow=1
	RECORDSOURCE = ''
	ALIGNMENT=0
	ACTIVECOL = 1
	BACKCOLOR=RGB(255,255,191)
	DISABLEDBACKCOLOR=RGB(255,255,191)
	FocusBackColor=RGB(198,255,191)
	LostBackColor=RGB(255,255,191)
	BACKSTYLE=1
	BORDERSTYLE=1
	MARGIN=0
	READONLY=.F.
	RECNO=1
	SELECTONENTRY = .T.
	SCROLLBARS = 0
	THEMES=.F.

	lnColumnAmount =1
	lnRowAmount=1
	lnGridRowCount = 1
	ADD OBJECT Button1 AS COMMANDBUTTON

	FUNCTION INIT
		LPARAMETERS logrd
		WITH THIS.Button1
			.BACKCOLOR=THIS.LostBackColor
			.DISABLEDBACKCOLOR=THIS.LostBackColor
			.VISUALEFFECT=2
			.THEMES=.F.
			.CAPTION=''
		ENDWITH
		THIS.logrd=logrd
		THIS.RECORDSOURCE = logrd.RECORDSOURCE
		THIS.ZORDER(0)
*		THIS.RESIZE

	FUNCTION Button1.MOUSEMOVE
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		NODEFAULT


	FUNCTION Button1.GOTFOCUS
		THIS.BACKCOLOR = THIS.PARENT.FocusBackColor
		THIS.FONTUNDERLINE = .T.

	FUNCTION Button1.LOSTFOCUS
		THIS.BACKCOLOR = THIS.PARENT.LostBackColor
		THIS.FONTUNDERLINE = .F.


	FUNCTION RESIZE
		WITH THIS
			.lnGridRowCount = GetGridRowCount(.logrd)
			.Button1.LEFT=0
			.Button1.TOP=0
			.Button1.WIDTH=.WIDTH
			.Button1.HEIGHT=.HEIGHT
		ENDWITH

	FUNCTION BIND
		LPARAMETERS lnObjectLeft, lnObjectTop, lnObjectWidth, lnObjectHeight, ;
			lnMyTopRecno,	;
			lnMyRelativeBaseRow, lngrdActiveRow, lnActiveCol, lnRowAmount, lnColumnAmount, luValue, lcTag
		WITH THIS
			.LEFT	= lnObjectLeft
			.TOP 	= lnObjectTop
			.WIDTH	= lnObjectWidth
			.HEIGHT	= lnObjectHeight
			.MyTopRecno = lnMyTopRecno
			.MyRelativeBaseRow = lnMyRelativeBaseRow
			.grdActiveRow = lngrdActiveRow
			.ACTIVECOL = lnActiveCol
			.lnColumnAmount = lnColumnAmount
			.lnRowAmount = lnRowAmount
			.TAG = lcTag
			WITH .Button1
				.CAPTION=totext(luValue)
				.TOOLTIPTEXT=.CAPTION
				.LEFT=1
				.TOP=1
				.WIDTH=MAX(2,THIS.WIDTH-2)
				.HEIGHT=MAX(2,THIS.HEIGHT-2)

*  
				.BACKCOLOR=RGB(255,255,191)
				.DISABLEDBACKCOLOR=RGB(255,255,191)


				DO CASE
					CASE .WIDTH>=.HEIGHT AND THIS.lnRowAmount>1
*						.ROTATION=0
						.ALIGNMENT=2
						.FONTSIZE = 11
						.WORDWRAP = .T.
					CASE .WIDTH>=.HEIGHT
						.ALIGNMENT=0
						.WORDWRAP = .F.
					OTHERWISE
						.ALIGNMENT=2
						.FONTSIZE = IIF(THIS.lnRowAmount>8,16,12)
						.WORDWRAP = .T.
				ENDCASE

			ENDWITH
		ENDWITH


	FUNCTION Button1.MouseUp
		LPARAMETERS nButton, nShift, nXCoord, nYCoord
		LOCAL lnCol
		WITH THIS.PARENT
					lcWindowName = thisform.Name

					lnRowTo = obj2Client(.logrd,1)+.logrd.HEADERHEIGHT+(.MyRelativeBaseRow-.5)* .logrd.ROWHEIGHT
					lnColumnTo=obj2Client(.logrd,2)+5
					lnRowFrom = MROW(lcWindowName,3)
					lnColumnFrom=MCOL(lcWindowName,3)
			.logrd.setfocus
			MOUSE CLICK AT lnRowTo, lnColumnTo DRAG TO lnRowFrom, lnColumnFrom PIXELS WINDOW (lcWindowName) LEFT
			.logrd.refresh
*			MOUSE CLICK AT lnRowTo, lnColumnTo PIXELS WINDOW &lcWindowName LEFT
*thisform.Command1.left=lnColumnTo
*thisform.Command1.top=lnRowTo
*			MOUSE AT lnRowFrom, lnColumnFrom  PIXELS WINDOW (lcWindowName)
*			DO FORM warn

*			.logrd.ACTIVATECELL(.MyRelativeBaseRow, lnCol )
			THIS.Parent.SETFOCUS
			THIS.SETFOCUS
*			.logrd.MOUSEMOVE(1,0,1,1)
		ENDWITH

	FUNCTION Button1.KEYPRESS
		LPARAMETERS nKeyCode, nShiftAltCtrl
		LOCAL lnCol
		WITH THIS.PARENT
			SELECT (.RECORDSOURCE)
			lnCurrentLeftColumn = FirstGridColumn(.logrd)
			lnCol = .ACTIVECOL-lnCurrentLeftColumn +1
			DO CASE

				CASE nKeyCode=4	&&  
					IF .ACTIVECOL+.lnColumnAmount>=.logrd.COLUMNCOUNT
						lnCol=2-lnCurrentLeftColumn
					ELSE
						lnCol = lnCol+.lnColumnAmount
					ENDIF
					.logrd.ACTIVATECELL(EVL(.grdActiveRow,.MyRelativeBaseRow), lnCol)
				CASE nKeyCode=19	&&  
					lnCol = lnCol - 1
					.logrd.ACTIVATECELL(EVL(.grdActiveRow,.MyRelativeBaseRow), IIF(lnCol<1-.logrd.LOCKCOLUMNS,.logrd.COLUMNCOUNT-.logrd.LOCKCOLUMNS,lnCol))
				CASE nKeyCode=5	&&  
loPatch=.F.
FOR EACH lo IN .Parent.Objects
IF LEFT(.Name,10)#LEFT(lo.Name,10) OR .Name==lo.Name
LOOP
ENDIF
IF .Top>lo.Top AND .ActiveCol = lo.ActiveCol AND (VARTYPE(loPatch)='L' OR lo.Top>loPatch.Top)
loPatch=lo
endif
next
IF VARTYPE(loPatch)='O'
loPatch.Button1.Click
loPatch=.f.
ELSE
SKIP -1 IN (.loGrd.RecordSource)
					IF BOF(.loGrd.RecordSource)
						GO TOP IN (.loGrd.RecordSource)
					ENDIF

NODEFAULT
ENDIF
.loGrd.Refresh
retu

				CASE nKeyCode=24	&&  
loPatch=.F.
FOR EACH lo IN .Parent.Objects
IF LEFT(.Name,10)#LEFT(lo.Name,10) OR .Name==lo.Name
LOOP
ENDIF
IF .Top<lo.Top AND .ActiveCol = lo.ActiveCol AND (VARTYPE(loPatch)='L' OR lo.Top<loPatch.Top)
loPatch=lo
endif
next
IF VARTYPE(loPatch)='O'
loPatch.Button1.Click
loPatch=.f.
ELSE
SKIP IN (.loGrd.RecordSource)
					IF EOF(.loGrd.RecordSource)
						GO BOTTOM IN (.loGrd.RecordSource)
					ENDIF
NODEFAULT
ENDIF

retu

				CASE nKeyCode = 3	&& PageDn
					SKIP INT(.lnGridRowCount)
					IF BOF()
						GO TOP
					ENDIF

				CASE nKeyCode =18	&& PageUp
					SKIP -INT(.lnGridRowCount)
					IF EOF()
						GO BOTTOM
					ENDIF

				OTHERWISE
					RETURN

			ENDCASE
			NODEFAULT
			.logrd.SETFOCUS
		ENDWITH
ENDDEFINE
